/**
***     HTMLViewerApp.c
***
***     ̃\[XR[h́AG[XgbvTXyhȂǂ̏Ă܂B
***     Copyright (C) 2006 SophiaCradle Incorporated.
***     All rights reserved.
**/

#include "AEEModGen.h"
#include "AEEAppGen.h"
#include "AEEStdLib.h"
#include "AEEShell.h"
#include "HTMLViewerApp.bid"
#include "AEEHTMLViewer.h"

typedef struct HTMLViewerApp {
    AEEApplet a; // Avbg\̂̐擪o͕K AEEApplet ^ɂ邱ƁB

    IDisplay* display;
    int width;
    int height;

    IHtmlViewer* htmlviewer; // IHTMLViewer C^[tF[X̃CX^Xϐ
    char url[256];           // URL i[z

    // Web ʐMp
    IWeb* web;               // IWeb C^[tF[X̃CX^Xϐ
    AEECallback callback;
    IWebResp* webresp;
    IGetLine* getline;
} HTMLViewerApp;

static boolean HTMLViewerApp_HandleEvent(HTMLViewerApp* app, AEEEvent eCode, uint16 wParam, uint32 dwParam);
static boolean OnAppStart(HTMLViewerApp* app);
static void HTMLVIEWERNotify(HTMLViewerApp* app, HViewNotify* notify);
static boolean OnAppStop(HTMLViewerApp* app);
static void WebAction_Start(HTMLViewerApp* app, const char* pszUrl);
static void WebAction_GotResp(void* p);
static void WebAction_Header(void* p, const char* name, GetLine* val);
static void WebAction_Status(void* p, WebStatus webstatus, void* val);
static void WebAction_Stop(HTMLViewerApp* app);
static void WebAction_ReadLines(void* p);

int AEEClsCreateInstance(AEECLSID ClsId, IShell* pIShell, IModule* po, void** ppObj)
{
    *ppObj = NULL;
    if (ClsId == AEECLSID_HTMLVIEWERAPP) {
        if (AEEApplet_New(sizeof(HTMLViewerApp), ClsId, pIShell, po, (IApplet**)ppObj, (AEEHANDLER)HTMLViewerApp_HandleEvent, NULL) == TRUE) {
            return AEE_SUCCESS;
        }
    }
    return EFAILED;
}

static boolean HTMLViewerApp_HandleEvent(HTMLViewerApp* app, AEEEvent eCode, uint16 wParam, uint32 dwParam)
{
    if (eCode == EVT_APP_START) {
        return OnAppStart(app);
    }
    else if (app->htmlviewer != NULL && IHTMLVIEWER_HandleEvent(app->htmlviewer, eCode, wParam, dwParam)) {
        // htmlviewer ɃCxgʒmBΊ֐IB
        return TRUE;
    }
    else {
        switch (eCode) {
            case EVT_APP_STOP:
                return OnAppStop(app);
        }
    }
    return FALSE;
}

// AvbgJnƂɌĂяoB
static boolean OnAppStart(HTMLViewerApp* app)
{
    AEEDeviceInfo devinfo;
    IShell* shell = app->a.m_pIShell;
    AEERect rc;
    char htmlData[] =
        "HtmlViewerApp<br /><br /><br />"
        "<a href=\"http://www.s-cradle.com/example/tabbrowser/\">Access to Sample Page</a><br /><br />"
        "<img src=\"http://www.s-cradle.com/images/SC_logo_3d.jpg\" width=\"92\" height=\"97\" alt=\"SC LOGO\" />";
    WebOpt webopts[2];

    app->display = NULL;
    ISHELL_CreateInstance(shell, AEECLSID_DISPLAY, (void**)&app->display);

    // ʃTCY擾
    ISHELL_GetDeviceInfo(shell, &devinfo);
    app->width = devinfo.cxScreen;
    app->height = devinfo.cyScreen;

    // IHtmlViewer C^[tF[X쐬
    app->htmlviewer = NULL;
    ISHELL_CreateInstance(shell, AEECLSID_HTML, (void**)&app->htmlviewer);
    // ANeBuʂ̗̈ݒ
    rc.x = 5;
    rc.y = 5;
    rc.dx = app->width - 10;
    rc.dy = app->height - 10;
    IHTMLVIEWER_SetRect(app->htmlviewer, &rc);
    // HTML ̓ǂݍ
    IHTMLVIEWER_ParseBuffer(app->htmlviewer, htmlData);
    // ʒmR[obN̐ݒ
    IHTMLVIEWER_SetNotifyFn(app->htmlviewer, (PFNHVIEWNOTIFY)HTMLVIEWERNotify, app);
    // Active ݒ
    IHTMLVIEWER_SetActive(app->htmlviewer, TRUE);

    app->web = NULL;
    ISHELL_CreateInstance(shell, AEECLSID_WEB, (void**)&app->web);

    // ڑ̃^CAEgԂ̐ݒ (ms)
    webopts[0].nId = WEBOPT_CONNECTTIMEOUT;
    webopts[0].pVal = (void*)10000;

    // WebOpt I}[N
    webopts[1].nId = WEBOPT_END;

    // IvVݒ
    IWEB_AddOpt(app->web, webopts);
    return TRUE;
}

// HTMLViewe ̃Cxg
static void HTMLVIEWERNotify(HTMLViewerApp* app, HViewNotify* notify)
{
    switch (notify->code) {
        // <a href="xxx">ꂽƂ
        case HVN_JUMP:
            DBGPRINTF(notify->u.jump.pszURL);
            STRCPY(app->url, notify->u.jump.pszURL);
            // ʐMJn
            WebAction_Start(app, app->url);
            break;

        default:
            DBGPRINTF("HTML NOTIFY: %d", notify->code);
            break;
    }
    return;
}

// AvbgIƂɌĂяoB
static boolean OnAppStop(HTMLViewerApp* app)
{
    IWEB_Release(app->web);
    IHTMLVIEWER_Release(app->htmlviewer);
    IDISPLAY_Release(app->display);
    return TRUE;
}

// ʐMJn
static void WebAction_Start(HTMLViewerApp* app, const char* url)
{
    CALLBACK_Init(&app->callback, WebAction_GotResp, app);
    IWEB_GetResponse(app->web,
                    (app->web, &app->webresp, &app->callback, url,
                    WEBOPT_HANDLERDATA, app,
                    WEBOPT_HEADER, "X-Method: GET\r\n",
                    WEBOPT_HEADERHANDLER, WebAction_Header,
                    WEBOPT_STATUSHANDLER, WebAction_Status,
                    WEBOPT_END));
    return;
}

// bZ[W̎擾JniIWeb gʐMIƂ̏j
static void WebAction_GotResp(void* p)
{
    HTMLViewerApp* app = (HTMLViewerApp*)p;
    WebRespInfo* info;

    info = IWEBRESP_GetInfo(app->webresp);
    DBGPRINTF("** got response...\n** info code: %d\n", info->nCode);
    if (info->pisMessage != NULL) {
        // ΃AhX邽߁A\ URL ݒ
        IHTMLVIEWER_SetURL(app->htmlviewer, app->url);
        // HTML ̓ǂݍ
        IHTMLVIEWER_LoadSource(app->htmlviewer, info->pisMessage);
    }
    else {
        DBGPRINTF("** no response\n");
    }
    WebAction_Stop(app);
    return;
}

// wb_[
static void WebAction_Header(void* p, const char* name, GetLine* val)
{
    if (name != NULL) {
        DBGPRINTF("%s:%s\n", name, val->psz);
    }
    else {
        DBGPRINTF("%s\n", val->psz);
    }
    return;
}

// Ԏ擾
static void WebAction_Status(void* p, WebStatus webstatus, void* val)
{
    char* string = 0;
    (void)val;

    switch (webstatus) {
        case WEBS_CANCELLED:
            string = "** cancelled...\n";
            break;

        case WEBS_GETHOSTBYNAME:
            string = "** finding host...\n";
            break;

        case WEBS_CONNECT:
            string = "** connecting...\n";
            break;

        case WEBS_SENDREQUEST:
            string = "** sending...\n";
            break;

        case WEBS_READRESPONSE:
            string = "** receiving...\n";
            break;

        case WEBS_GOTREDIRECT:
            string = "** redirect...\n";
            break;

        case WEBS_CACHEHIT:
            string = "** cache hit...\n";
            break;
    }
    if (string != NULL) {
        DBGPRINTF("%s", string);
    }
    return;
}

// ʐMI
static void WebAction_Stop(HTMLViewerApp* app)
{
    CALLBACK_Cancel(&app->callback);
    if (app->getline != NULL) {
       IGETLINE_Release(app->getline);
       app->getline = NULL;
    }
    if (app->webresp != NULL) {
       IWEBRESP_Release(app->webresp);
       app->webresp = NULL;
    }
    return;
}

// bZ[W擾
static void WebAction_ReadLines(void* p)
{
    int value;
    GetLine getline;
    HTMLViewerApp* app = (HTMLViewerApp*)p;

    value = IGETLINE_GetLine(app->getline, &getline, IGETLINE_LF);
    if (value == IGETLINE_WAIT) {
        CALLBACK_Init(&app->callback, WebAction_ReadLines, app);
        IGETLINE_Peekable(app->getline, &app->callback);
    }
    else {
        DBGPRINTF("%s\n", getline.psz, NULL, TRUE);
        if (!IGETLINE_Exhausted(value)) {
            CALLBACK_Init(&app->callback, WebAction_ReadLines, app);
            IGETLINE_Readable(app->getline, &app->callback);
        }
        else {
            DBGPRINTF((value == IGETLINE_ERROR) ? ("\n** error\n") : ("\n** end\n"));
            WebAction_Stop(app);
        }
    }
    return;
}
